VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cWmiInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function GetWmiInfo(ByVal xi_strComputerName As String) As Variant
On Error Resume Next
   Dim p_objWbemRoot                   As SWbemServices
   Dim p_vntRtn                        As Variant
   Dim p_lngIndex                      As Long
   
   ' ------------------------------------------
   ' Set the root object, based on the name
   '     of the computer
   ' ------------------------------------------
   Set p_objWbemRoot = GetObject("winMgmts:\\" & xi_strComputerName)

   ' ------------------------------------------
   ' We won't have 2000 items, but don't want
   '     to be constantly redimming the array
   ' ------------------------------------------
   ReDim p_vntRtn(0 To 1, 0 To 2000) As String
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_OperatingSystem
   ' ------------------------------------------
   Debug.Print "Before Win32_OperatingSystem"
   GetOsData p_objWbemRoot, p_vntRtn
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_ComputerSystem
   ' ------------------------------------------
   Debug.Print "Before Win32_ComputerSystem"
   GetComputerSystemData p_objWbemRoot, p_vntRtn
   
   ' ------------------------------------------
   ' First 2 calls return a fixed # of items
   '     (0 to 27). From here on out, it will
   '     be a variable number
   ' ------------------------------------------
   p_lngIndex = 27
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_LogicalDisk
   ' ------------------------------------------
   Debug.Print "Before Win32_LogicalDisk"
   GetLogicalDiskData p_objWbemRoot, p_vntRtn, p_lngIndex
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_Printer
   ' ------------------------------------------
   Debug.Print "Before Win32_Printer"
   GetPrintersData p_objWbemRoot, p_vntRtn, p_lngIndex
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_Share
   ' ------------------------------------------
   Debug.Print "Before Win32_Share"
   GetShareData p_objWbemRoot, p_vntRtn, p_lngIndex
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_Service
   ' ------------------------------------------
   Debug.Print "Before Win32_Service"
   GetServicesData p_objWbemRoot, p_vntRtn, p_lngIndex
   
   ' ------------------------------------------
   ' Enumerate the instances of Win32_NetworkAdapterConfiguration
   ' ------------------------------------------
   Debug.Print "Before Win32_NetworkAdapterConfiguration"
   GetNicData p_objWbemRoot, p_vntRtn, p_lngIndex
   Debug.Print "After Win32_NetworkAdapterConfiguration"
   
   ' ------------------------------------------
   ' Clean out the extra entries
   ' ------------------------------------------
   ReDim Preserve p_vntRtn(0 To 1, 0 To p_lngIndex) As String

   ' ------------------------------------------
   ' Set the return value
   ' ------------------------------------------
   GetWmiInfo = p_vntRtn
   
Exit Function
ErrTrap:
   Debug.Print
End Function

Private Sub GetNicData(ByVal xi_SWbemServices As SWbemServices, _
                       ByRef xio_vntRtn As Variant, _
                       ByRef xio_lngIndex As Long)
On Error Resume Next
   Dim p_vntTmp                        As Variant
   Dim NicsData                        As SWbemObjectSet
   Dim Nic_Data                        As SWbemObject
   Dim Property                        As SWbemProperty

   Set NicsData = xi_SWbemServices.InstancesOf("Win32_NetworkAdapterConfiguration")
   For Each Nic_Data In NicsData
      ReDim p_vntTmp(0 To 1, 0 To 3) As String
      
      For Each Property In Nic_Data.Properties_
         With Property
            Select Case Property.Name
               Case "Caption"
                  p_vntTmp(0, 0) = "NIC Name"
                  p_vntTmp(1, 0) = .Value
               Case "ServiceName"
                  p_vntTmp(0, 1) = vbTab & "NIC Service Name"
                  p_vntTmp(1, 1) = .Value
               Case "Description"
                  p_vntTmp(0, 2) = vbTab & "NIC Description"
                  p_vntTmp(1, 2) = .Value
               Case "MACAddress"
                  p_vntTmp(0, 3) = vbTab & "MAC Address"
                  p_vntTmp(1, 3) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
      
      If Len(Trim$(p_vntTmp(1, 0))) > 0 Then
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 0)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 0)

         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 1)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 1)
      
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 2)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 2)

         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 3)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 3)
      End If
      
   Next

End Sub

Private Sub GetServicesData(ByVal xi_SWbemServices As SWbemServices, _
                            ByRef xio_vntRtn As Variant, _
                            ByRef xio_lngIndex As Long)
On Error Resume Next
   Dim p_vntTmp                        As Variant
   Dim ServicesData                    As SWbemObjectSet
   Dim Service_Data                    As SWbemObject
   Dim Property                        As SWbemProperty

   Set ServicesData = xi_SWbemServices.InstancesOf("Win32_Service")
   For Each Service_Data In ServicesData
      ReDim p_vntTmp(0 To 1, 0 To 5) As String
      
      For Each Property In Service_Data.Properties_
         With Property
            Select Case Property.Name
               Case "Started"
                  p_vntTmp(0, 0) = "Started"
                  p_vntTmp(1, 0) = .Value
               Case "State"
                  p_vntTmp(0, 1) = "State"
                  p_vntTmp(1, 1) = .Value
               Case "DisplayName"
                  p_vntTmp(0, 2) = "Service Display Name"
                  p_vntTmp(1, 2) = .Value
               Case "Description"
                  p_vntTmp(0, 3) = vbTab & "Description"
                  p_vntTmp(1, 3) = .Value
               Case "PathName"
                  p_vntTmp(0, 4) = vbTab & "Path Name"
                  p_vntTmp(1, 4) = .Value
               Case "StartName"
                  p_vntTmp(0, 5) = vbTab & "Start Name"
                  p_vntTmp(1, 5) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
      
      If Trim$(UCase$(p_vntTmp(1, 0))) = "TRUE" Then
         If Trim$(UCase$(p_vntTmp(1, 1))) = "RUNNING" Then
            xio_lngIndex = xio_lngIndex + 1
            xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 2)
            xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 2)
   
            xio_lngIndex = xio_lngIndex + 1
            xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 3)
            xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 3)
            
            xio_lngIndex = xio_lngIndex + 1
            xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 4)
            xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 4)
   
            xio_lngIndex = xio_lngIndex + 1
            xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 5)
            xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 5)
         End If
      End If
      
   Next
   
End Sub

Private Sub GetShareData(ByVal xi_SWbemServices As SWbemServices, _
                         ByRef xio_vntRtn As Variant, _
                         ByRef xio_lngIndex As Long)
On Error Resume Next
   Dim p_vntTmp                        As Variant
   Dim SharesData                      As SWbemObjectSet
   Dim Share_Data                      As SWbemObject
   Dim Property                        As SWbemProperty

   Set SharesData = xi_SWbemServices.InstancesOf("Win32_Share")
   For Each Share_Data In SharesData
      ReDim p_vntTmp(0 To 1, 0 To 1) As String
      
      For Each Property In Share_Data.Properties_
         With Property
            Select Case Property.Name
               Case "Name"
                  p_vntTmp(0, 0) = "Share Name"
                  p_vntTmp(1, 0) = .Value
               Case "Path"
                  p_vntTmp(0, 1) = vbTab & "Share Path"
                  p_vntTmp(1, 1) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
      
      If Len(Trim$(p_vntTmp(1, 0))) > 0 Then
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 0)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 0)

         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 1)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 1)

      End If
      
   Next
   
End Sub

Private Sub GetPrintersData(ByVal xi_SWbemServices As SWbemServices, _
                            ByRef xio_vntRtn As Variant, _
                            ByRef xio_lngIndex As Long)
On Error Resume Next
   Dim p_vntTmp                        As Variant
   Dim PrintersData                    As SWbemObjectSet
   Dim Printer_Data                    As SWbemObject
   Dim Property                        As SWbemProperty
                           
   Set PrintersData = xi_SWbemServices.InstancesOf("Win32_Printer")
   For Each Printer_Data In PrintersData
      ReDim p_vntTmp(0 To 1, 0 To 4) As String
      
      For Each Property In Printer_Data.Properties_
         With Property
            Select Case Property.Name
               Case "Name"
                  p_vntTmp(0, 0) = "Net Printer Name"
                  p_vntTmp(1, 0) = .Value
               Case "DriverName"
                  p_vntTmp(0, 1) = vbTab & "Driver Name"
                  p_vntTmp(1, 1) = .Value
               Case "Network"
                  p_vntTmp(0, 2) = vbTab & "Is Network Printer"
                  p_vntTmp(1, 2) = .Value
               Case "PortName"
                  p_vntTmp(0, 3) = vbTab & "Port Name"
                  p_vntTmp(1, 3) = .Value
               Case "ShareName"
                  p_vntTmp(0, 4) = vbTab & "Share Name"
                  p_vntTmp(1, 4) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
      
      If Len(Trim$(p_vntTmp(1, 0))) > 0 Then
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 0)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 0)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 1)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 1)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 2)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 2)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 3)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 3)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 4)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 4)
      End If
      
   Next
   
End Sub

Private Sub GetLogicalDiskData(ByVal xi_SWbemServices As SWbemServices, _
                                 ByRef xio_vntRtn As Variant, _
                                 ByRef xio_lngIndex As Long)
On Error Resume Next
   Dim p_vntTmp                        As Variant
   Dim LogicalDisks                    As SWbemObjectSet
   Dim LogicalDisk                     As SWbemObject
   Dim Property                        As SWbemProperty
   
   Set LogicalDisks = xi_SWbemServices.InstancesOf("Win32_LogicalDisk")
   
   For Each LogicalDisk In LogicalDisks
      ReDim p_vntTmp(0 To 1, 0 To 6) As String
      
      For Each Property In LogicalDisk.Properties_
         With Property
            Select Case Property.Name
               Case "Name"
                  p_vntTmp(0, 0) = "Drive Letter"
                  p_vntTmp(1, 0) = .Value
               Case "FileSystem"
                  p_vntTmp(0, 1) = vbTab & "FileSystem"
                  p_vntTmp(1, 1) = .Value
               Case "Description"
                  p_vntTmp(0, 2) = vbTab & "Description"
                  p_vntTmp(1, 2) = .Value
               Case "Size"
                  p_vntTmp(0, 3) = vbTab & "Disk Size"
                  p_vntTmp(1, 3) = TransMeg(.Value) & " Megs"
               Case "FreeSpace"
                  p_vntTmp(0, 4) = vbTab & "Free Space"
                  p_vntTmp(1, 4) = TransMeg(.Value) & " Megs"
               Case "VolumeName"
                  p_vntTmp(0, 5) = vbTab & "Volume Name"
                  p_vntTmp(1, 5) = .Value
               Case "ProviderName"
                  p_vntTmp(0, 6) = vbTab & "Remote Name"
                  p_vntTmp(1, 6) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
         
      Next
         
      If Len(Trim$(p_vntTmp(1, 0))) > 0 Then
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 0)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 0)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 1)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 1)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 2)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 2)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 3)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 3)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 4)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 4)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 5)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 5)
         
         xio_lngIndex = xio_lngIndex + 1
         xio_vntRtn(0, xio_lngIndex) = p_vntTmp(0, 6)
         xio_vntRtn(1, xio_lngIndex) = p_vntTmp(1, 6)
      End If
         
   Next

End Sub

Private Sub GetComputerSystemData(ByVal xi_SWbemServices As SWbemServices, _
                                  ByRef xio_vntRtn As Variant)
On Error Resume Next
   Dim ComputerSysSet                  As SWbemObjectSet
   Dim ComputerSystem                  As SWbemObject
   Dim Property                        As SWbemProperty

   Set ComputerSysSet = xi_SWbemServices.InstancesOf("Win32_ComputerSystem")
   
   For Each ComputerSystem In ComputerSysSet
      For Each Property In ComputerSystem.Properties_
         With Property
            Select Case Property.Name
               Case "TotalPhysicalMemory"
                  xio_vntRtn(0, 0) = "Total Physical Memory"
                  xio_vntRtn(1, 0) = TransK(.Value) & " K"
               Case "SystemType"
                  xio_vntRtn(0, 14) = "System Type"
                  xio_vntRtn(1, 14) = .Value
               Case "Domain"
                  xio_vntRtn(0, 15) = "Domain"
                  xio_vntRtn(1, 15) = .Value
               Case "NumberOfProcessors"
                  xio_vntRtn(0, 18) = "Number of Processors"
                  xio_vntRtn(1, 18) = .Value
               Case "PrimaryOwnerName"
                  xio_vntRtn(0, 20) = "Primary Owner Name"
                  xio_vntRtn(1, 20) = .Value
               Case "Description"
                  xio_vntRtn(0, 25) = "Description"
                  xio_vntRtn(1, 25) = .Value
               Case "EnableDaylightSavingsTime"
                  xio_vntRtn(0, 26) = "Daylight Savings Enabled"
                  xio_vntRtn(1, 26) = .Value
               Case "UserName"
                  xio_vntRtn(0, 27) = "Current User Name"
                  xio_vntRtn(1, 27) = .Value
               Case Else
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
   Next
   
End Sub

Private Sub GetOsData(ByVal xi_SWbemServices As SWbemServices, _
                      ByRef xio_vntRtn As Variant)
On Error Resume Next
   Dim OSSet                           As SWbemObjectSet
   Dim OS                              As SWbemObject
   Dim Property                        As SWbemProperty

   Set OSSet = xi_SWbemServices.InstancesOf("Win32_OperatingSystem")
   
   For Each OS In OSSet
      For Each Property In OS.Properties_
         With Property
            Select Case .Name
               Case "FreePhysicalMemory"
                  xio_vntRtn(0, 1) = "Free Physical Memory"
                  xio_vntRtn(1, 1) = TransK(.Value) & " K"
               Case "FreeVirtualMemory"
                  xio_vntRtn(0, 2) = "Free Virtual Memory"
                  xio_vntRtn(1, 2) = TransK(.Value) & " K"
               Case "TotalVirtualMemorySize"
                  xio_vntRtn(0, 3) = "Total Virtual Memmory Size"
                  xio_vntRtn(1, 3) = TransK(.Value) & " K"
               Case "TotalVisibleMemorySize"
                  xio_vntRtn(0, 4) = "Total Visible Memory Size"
                  xio_vntRtn(1, 4) = TransK(.Value) & " K"
               Case "SizeStoredInPagingFiles"
                  xio_vntRtn(0, 5) = "Size Stored in Paging File(s)"
                  xio_vntRtn(1, 5) = TransK(.Value) & " K"
               Case "FreeSpaceInPagingFiles"
                  xio_vntRtn(0, 6) = "Free Space in Paging File(s)"
                  xio_vntRtn(1, 6) = TransK(.Value) & " K"
               Case "CodeSet"
                  xio_vntRtn(0, 7) = "Code Set"
                  xio_vntRtn(1, 7) = .Value
               Case "CountryCode"
                  xio_vntRtn(0, 8) = "Country Code"
                  xio_vntRtn(1, 8) = .Value
               Case "Locale"
                  xio_vntRtn(0, 9) = "Locale"
                  xio_vntRtn(1, 9) = .Value
               Case "InstallDate"
                  xio_vntRtn(0, 10) = "OS Installation Date"
                  xio_vntRtn(1, 10) = TransDate(.Value)
               Case "LastBootUpTime"
                  xio_vntRtn(0, 11) = "Last Boot-up Time"
                  xio_vntRtn(1, 11) = TransDate(.Value)
               Case "Organization"
                  xio_vntRtn(0, 12) = "Organization"
                  xio_vntRtn(1, 12) = .Value
               Case "Version"
                  xio_vntRtn(0, 13) = "Version"
                  xio_vntRtn(1, 13) = .Value
               Case "WindowsDirectory"
                  xio_vntRtn(0, 16) = "Windows Directory"
                  xio_vntRtn(1, 16) = .Value
               Case "SystemDirectory"
                  xio_vntRtn(0, 17) = "System Directory"
                  xio_vntRtn(1, 17) = .Value
               Case "RegisteredUser"
                  xio_vntRtn(0, 19) = "Registered User"
                  xio_vntRtn(1, 19) = .Value
               Case "NumberOfUsers"
                  xio_vntRtn(0, 21) = "Number of Users"
                  xio_vntRtn(1, 21) = .Value
               Case "NumberOfProcesses"
                  xio_vntRtn(0, 22) = "Number of Processes"
                  xio_vntRtn(1, 22) = .Value
               Case "BuildType"
                  xio_vntRtn(0, 23) = "Build Type"
                  xio_vntRtn(1, 23) = .Value
               Case "Caption"
                  xio_vntRtn(0, 24) = "Caption"
                  xio_vntRtn(1, 24) = .Value
               Case Else
                  On Error Resume Next
                  ' Ignore the rest
                  'Debug.Print .Name, .Value
            End Select
         End With
      Next
   Next

End Sub

Private Function TransK(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_dblFactor                     As Double
   Dim p_dblMegs                       As Double
   
   p_dblFactor = 1024#
   p_dblMegs = CDbl(xi_vntRawNumber) / p_dblFactor
   
   TransK = Format$(CStr(p_dblMegs), "Standard")
   
End Function

Private Function TransMeg(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_dblFactor                     As Double
   Dim p_dblMegs                       As Double
   
   p_dblFactor = 1024# * 1024#
   p_dblMegs = CDbl(xi_vntRawNumber) / p_dblFactor
   
   TransMeg = Format$(CStr(p_dblMegs), "Standard")
   
End Function

Private Function TransNum(ByVal xi_vntRawNumber As Variant) As String
On Error Resume Next
   Dim p_strTmp                        As String
   
   p_strTmp = Trim$(Format$(xi_vntRawNumber, "Standard"))
   TransNum = Mid$(p_strTmp, 1, Len(p_strTmp) - 3)
   
End Function

Private Function TransDate(ByVal xi_strUntranslatedDate As String) As String
On Error Resume Next
   
   TransDate = CStr(DateSerial(Left$(xi_strUntranslatedDate, 4), _
                               Mid$(xi_strUntranslatedDate, 5, 2), _
                               Mid$(xi_strUntranslatedDate, 7, 2))) _
               & " -- " & _
               CStr(TimeSerial(Mid$(xi_strUntranslatedDate, 9, 2), _
                               Mid$(xi_strUntranslatedDate, 11, 2), _
                               Mid$(xi_strUntranslatedDate, 13, 2)))
                                  
End Function
